' -----[ Title ]------------------------------------------------------
'
' File......: DTR103LCD.BAS
' Purpose...: Testprogram for LCD's at DTR103.
' Commands..: LCD, CLS, LOWERLINE, SHIFTLCD, SHIFTCURSOR, HOME, CURSOR, DISPLAY
'             and Marks internal routine
' Author....: Mike Eitel
' Version...: 1.00AVR
' MCU.......: AVR 8515
' Started...: 010507
' Updated...: 010507
'
' -----[ Program Description ]--------------------------------------------------
'
' This program implements LCD testroutines and uses DTR103 Simmstick
'
' -----[ Disclaimer ]-----------------------------------------------------------
'
' This example is offered on an "AS IS" basis, no warranty expressed or implied.
' The programers disclaim liability of any damages associated with the use of the
' hardware or software described herein.
' You use it on your own risk. We are not able to provide any free support.
'
' Copyright (c) 2001 Mike Eitel all rights reserved
'
' -----[ Revision History ]-----------------------------------------------------
'
' 1.00 - Version 1.00AVR  Diverent emprouvements and test BASCOM 1.11.6.2  Mike Eitel
'
'' DTR103 display in PIN MODE
'
' ***************** Don't forget to reset the XRAM waitstates !!! ***************
'
' with the config lcdpin statement you can override the compiler settings
$crystal = 9830488

' with the config lcdpin statement you can override the compiler settings
Config Lcdpin = Pin , Db4 = Porta.4 , Db5 = Porta.5 , Db6 = Porta.6 , Db7 = Porta.7 , E = Porta.3 , Rs = Porta.1
Config Lcdmode = Port
'$sim
' -----[ Configuration parameters  ]--------------------------------------------
Const Characters = 20                             ' Physikal description of LCD
Const Lines = 4                                   ' Physikal description of LCD

'Config Lcd = Characters * Lines                            ' Would be nicer for indirect but....
Config Lcd = 20 * 4                               ' CHANGE here to actual configuration

Cursor Off Noblink                                ' Dont disturb with cursor

Dim Character As Byte                             ' This is the visible character
Dim Place As Byte                                 ' Place in the line
Dim Line As Byte                                  ' Line of the display
Dim A As Byte                                     ' Temporary variable

' -----[ Start of the program  ]------------------------------------------------
Begin:

   Character = 0                                  ' Get defined startup values
   Place = 0                                      ' Get defined startup values
   Character = 0                                  ' Get defined startup values

   Cls                                            ' Start the show
   Home Upper                                     ' At the top
   Cursor Off Noblink                             ' Cursor is still off

   '-----[ Show all characters ]------------------------------------------------
   Lcd "  All Characters"
   Wait 2
   Cls

   For Character = 0 To 255                       ' Show all preprogramed characters
       If Character = 0 Then
          Cls                                     ' Clear only at start
       End If
       Place = Character Mod Characters           ' Restrict if line gets too long
       Incr Place                                 ' Do not forget the 0
       Line = Character / Characters              ' Get theoretical line number
       Line = Line Mod Lines                      ' and cut down to display's physic
       Incr Line                                  ' Regards first line

       Upperline                                  ' Keyword for first line
       Locate Line , Place
       Lcd Chr(character)                         ' Display this at the chosen place
       Waitms 10
   Next Character
   Wait 1

   '-----[ Diverent games for manipulation of whole lines ]---------------------
   Cls
   Cursor Off Noblink                             ' Don't disturb by cursor blinking
   Home Upper                                     ' Start in first line
   Lcd "  Line Games        "
   Wait 2
   Cls

   Upperline                                      ' Display this at the first line
   Lcd "__Line one"                               ' The Text
   Lowerline                                      ' Select the second  line
   Lcd "__Line two"
   Thirdline                                      ' The third line
   Lcd "__Line three"
   Fourthline                                     ' And the last line
   Lcd "__Line four"
   Wait 2

   ' Make a jumpmove of the text to the middle of the display
   Shiftlcd Right                                 ' Shift the text one right
   Shiftlcd Right                                 ' Shift the text one right
   Shiftlcd Right                                 ' Shift the text one right
   Shiftlcd Right                                 ' Shift the text one right
   Shiftlcd Right                                 ' Shift the text one right
   Shiftlcd Right                                 ' Shift the text one right
   Shiftlcd Right                                 ' Shift the text one right
   Shiftlcd Right                                 ' Shift the text one right
   Wait 1

   Home Upper                                     ' This is moving back to the first line
   Lcd "A"                                        ' Overide only first character
   Waitms 255                                     ' Make visible what happens
   Home Lower                                     ' Begin of the second line
   Lcd "B"                                        ' Overide only first character
   Waitms 255                                     ' Make visible what happens
   Home Third                                     ' Begin of the third line
   Lcd "C"                                        ' Overide only first character
   Waitms 255                                     ' Make visible what happens
   Home Fourth                                    ' Begin of the fourth line
   Lcd "D"                                        ' Overide only first character
   Wait 2

   For A = 1 To 8                                 ' For eight places
       Shiftlcd Right                             ' Shift the text to the right
       Waitms 255                                 ' Wait a moment
   Next                                           ' End of shifting right

   For A = 1 To 8                                 ' Same back to the left
       Shiftlcd Left                              ' Shift the text to the left
       Waitms 20                                  ' Wait a moment
   Next                                           ' End of second shifting
   Wait 2

   '-----[ Show handmade dynamic generated characters ]-------------------------

   Cls
   'Now lets build a special character while the first number are the characternumbers (0-7)
   'The other numbers are the rowvalues.   Use the LCD tool to insert these lines
   Deflcdchar 0 , 16 , 31 , 16 , 16 , 16 , 16 , 16 , 16
   Deflcdchar 1 , 8 , 8 , 31 , 8 , 8 , 8 , 8 , 8
   Deflcdchar 2 , 4 , 4 , 4 , 31 , 4 , 4 , 4 , 4
   Deflcdchar 3 , 2 , 2 , 2 , 2 , 31 , 2 , 2 , 2
   Deflcdchar 4 , 1 , 1 , 1 , 1 , 1 , 31 , 1 , 1
   Deflcdchar 5 , 16 , 16 , 8 , 4 , 4 , 2 , 1 , 1
   Deflcdchar 6 , 1 , 1 , 2 , 4 , 4 , 8 , 16 , 16
   Deflcdchar 7 , 31 , 14 , 4 , 14 , 14 , 4 , 14 , 31
   'Important that a CLS is following the deflcdchar statements because it will set the controller back in datamode
   Cls

   Upperline
   Lcd "  Special Characters"
   'print the special character
   Lcd Chr(0) ; Chr(1) ; Chr(2) ; Chr(3) ; Chr(4) ; Chr(5) ; Chr(6) ; Chr(7)       ' Do it
   Wait 2

   '-----[ Show games with the cursor ]-----------------------------------------
   Cls                                            ' Now see cursor treatment
   Home Upper                                     ' Cursor is still off
   Lcd "  Cursor Variation"
   Waitms 100

   Home Lower
   Cursor On Noblink                              ' Dont disturb by blinking
   Lcd "Cursor ON NOBLINK "
   Wait 2

   Home Third
   Cursor Off Blink                               ' Now see the Cursor
   Lcd "Cursor OFF  BLINK "
   Wait 2

   Home Fourth
   Cursor On Blink                                ' Cursor blinks ?
   Lcd "Cursor ON   BLINK "
   Wait 2

   Home Upper                                     ' Move cursor over display
   Lcd "  Moving Cursor     "

   Cursor On Blink                                ' Best way to see the movements
   Home Upperline                                 ' Start at first position
   For A = 1 To 19                                ' Show all positions in line
       Shiftcursor Right
   Waitms 255
   Next A

   Home Lowerline                                 ' Next line
   For A = 1 To 19                                ' Show all positions in line
       Shiftcursor Right
   Waitms 255
   Next A

   Home Thirdline                                 ' Next line
   For A = 1 To 19                                ' Show all positions in line
       Shiftcursor Right
   Waitms 255
   Next A

   Home Fourthline                                ' Next line
   For A = 1 To 19                                ' Show all positions in line
       Shiftcursor Right
   Waitms 255
   Next A

   Wait 2
   Cursor Off Noblink                             ' Clear disturbing cursor

   Cls
   Lcd " Switch OFF Display "                     ' Write in first line
   Wait 2
   Display Off                                    ' Switch it OFF
   Home Upper
   Lcd "                    "                     ' Clear first line
   Lcd " Switch ON  Display "                     ' Write third line
   Wait 2
   Display On                                     ' Switch it ON again
   Wait 1

   '-----[ Now use an internal routine ]----------------------------------------
   Home Upper                                     ' Alternative routine
   Lcd "  Internal routine  "

   For Character = 0 To 255                       ' Show all preprogramed characters
       _temp1 = Character                         ' value into ACC
      ' Please don't ask me why it works, but it does !!!
      !rCall _write_lcd                           ' put it on LCD
       Waitms 50
   Next Character
   Wait 3

   '-----[ End of the Show ]----------------------------------------------------
   Cls
   Home Lower                                     ' Write into second line
   Lcd "  End of the Show"
   Wait 10                                        ' For the applaus

 Goto Begin                                       ' Restart the Show

 End                                              ' As it should be
 '-----------------[ This is the End ]------------------------------------------